// -*- mode: c++ -*-
#pragma once

#include "DakkarColor.h"

const cRGB num_breathe() { return breath_compute(170); }

#define D_C(r,g,b) ((DakkarColor::colorSrc){ \
  .value_or_function = DakkarColor::colorSrc::VALUE, \
  .vf = { .value = CRGB(r,g,b) } \
})
#define D_Cn(color) ((DakkarColor::colorSrc){ \
  .value_or_function = DakkarColor::colorSrc::VALUE, \
  .vf = { .value = color } \
})
#define D_F(f) ((DakkarColor::colorSrc){ \
  .value_or_function = DakkarColor::colorSrc::FUNCTION, \
  .vf = { .function = f } \
})

// themes could be adapted from https://github.com/jdlien/Kaleidoscope-LEDEffect-FunctionalColor/blob/master/src/Kaleidoscope-LEDEffect-FunctionalColor.h

static constexpr DakkarColor::colorSrc dark_colors[COLOR_COUNT] =
  {
   [Off]        = D_C(0,0,0),
   [Base]       = D_C(0,0,0),
   [Base2]      = D_C(89,89,89),
   [Screen]     = D_C(78,13,80),
   [Lnch]       = D_C(128,25,87),
   [Wind]       = D_C(65,128,52),
   [View]       = D_C(51,102,128),
   [Media]      = D_C(123,128,47),
   [Ms]         = D_C(128,126,21),
   [MsB]        = D_C(108,26,0),
   [MsW]        = D_C(110,128,27),
   [Func]       = D_C(115,0,128),
   [Func2]      = D_C(14,43,80),
   [Num]        = D_C(150,0,0),
   [NumBreathe] = D_F(num_breathe),
  };

static constexpr DakkarColor::colorSrc bright_colors[COLOR_COUNT] =
  {
   [Off] = D_C(0,0,0),
   [Base] = D_C(50,50,50),
   [Base2] = D_C(50,50,50),
   [Screen] = D_C(0,0,100),
   [Lnch] = D_C(0,0,100),
   [Wind] = D_C(100,0,0),
   [View] = D_C(0,100,0),
   [Media] = D_C(0,100,0),
   [Ms] = D_C(50,50,0),
   [MsB] = D_C(30,0,30),
   [MsW] = D_C(0,30,30),
   [Func] = D_C(50,50,80),
   [Func2] = D_C(50,50,80),
   [Num] = D_C(100,0,0),
   [NumBreathe] = D_F(num_breathe),
  };

static DakkarColor DakkarColorDark(color_keymaps,dark_colors);
static DakkarColor DakkarColorBright(color_keymaps,bright_colors);
